//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <trade/trade.mqh>

int GetTotalResultOne;
int GetTotalResultTwo;
int GetTotalResultThree;
int GetTotalResultFour;
int GetTotalResultFive;
int GetTotalResultSix;
int GetTotalResultSeven;
int GetTotalResultEight;
int GetTotalResultNine;
int GetTotalResultTen;
int GetTotalResultEleven;
int GetTotalResultTwelve;
int GetTotalResultThirteen;
int GetTotalResultFourteen;
int GetTotalResultFifteen;
int GetTotalResultSixteen;
int GetTotalResultSeventeen;
int GetTotalResultEighteen;
int GetTotalResultNineteen;
int GetTotalResultTwenty;
int GetTotalResultTwentyOne;
int GetTotalResultTwentyTwo;

int MACD_handle;
int Stochastic_handle;
int ADX_handle;
int IchimokuCloud_handle;
int WPR;
int Bull;
int Bear;
int AO;
int RSI;
int CCI;
int Momentum;

int EMAOneDay10;
int EMAOneDay20;
int EMAOneDay30;
int EMAOneDay50;
int EMAOneDay100;
int EMAOneDay200;
int SMAOneDay10;
int SMAOneDay20;
int SMAOneDay30;
int SMAOneDay50;
int SMAOneDay100;
int SMAOneDay200;

bool RSIisRising;
bool RSIisFalling;
bool CCIisRising;
bool CCIisFalling;
bool WilliamsRPercentageisRising;
bool WilliamsRPercentageisFalling;
bool BullPowerisFalling;
bool BearPowerisRising;
bool ADXIsRising;

CTrade trade;
input double Lots = 0.01;
input int CloseTimeHour = 12;
input int CloseTimeMin = 0;
input int CloseTimeSec = 0;
input ENUM_DAY_OF_WEEK CloseTimeDayOfTheWeek = -1;
input double Leverage = 2000;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   MACD_handle = iMACD(_Symbol,PERIOD_CURRENT,12,26,9,PRICE_CLOSE);
   Stochastic_handle = iStochastic(_Symbol,PERIOD_CURRENT,14,3,3,MODE_SMA,STO_CLOSECLOSE);
   ADX_handle = iADX(_Symbol,PERIOD_CURRENT,14);
   IchimokuCloud_handle = iIchimoku(_Symbol,PERIOD_CURRENT,9,26, 52);
   WPR = iWPR(_Symbol,PERIOD_CURRENT, 14);
   Bull = iBullsPower(_Symbol,PERIOD_CURRENT,13);
   Bear = iBearsPower(_Symbol,PERIOD_CURRENT,13);
   AO = iAO(_Symbol,PERIOD_CURRENT);
   RSI = iRSI(_Symbol,PERIOD_CURRENT,14,PRICE_CLOSE);
   CCI = iCCI(_Symbol,PERIOD_CURRENT,20,PRICE_CLOSE);
   Momentum = iMomentum(_Symbol,PERIOD_CURRENT,10,PRICE_CLOSE);
   EMAOneDay10 = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay20 = iMA(_Symbol,PERIOD_CURRENT,20,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay30 = iMA(_Symbol,PERIOD_CURRENT,30,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay50 = iMA(_Symbol,PERIOD_CURRENT,50,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay100 = iMA(_Symbol,PERIOD_CURRENT,100,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay200 = iMA(_Symbol,PERIOD_CURRENT,200,0,MODE_EMA,PRICE_CLOSE);
   SMAOneDay10 = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay20 = iMA(_Symbol,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay30 = iMA(_Symbol,PERIOD_CURRENT,30,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay50 = iMA(_Symbol,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay100 = iMA(_Symbol,PERIOD_CURRENT,100,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay200 = iMA(_Symbol,PERIOD_CURRENT,200,0,MODE_SMA,PRICE_CLOSE);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(PositionsTotal() > 0 && CloseTimeDayOfTheWeek > 0)
     {
      MqlDateTime structTime;
      TimeCurrent(structTime);
      structTime.hour = CloseTimeHour;
      structTime.min = CloseTimeMin;
      structTime.sec = CloseTimeSec;
      datetime timeClose = StructToTime(structTime);

      if(TimeCurrent() >= timeClose && structTime.day_of_week == CloseTimeDayOfTheWeek)
        {
         Print("CLOSE ALL POSITIONS!");
         Print("Current time: ",TimeCurrent()," >= ","Closing time: ",timeClose);
         for(int i = PositionsTotal()-1; i>=0; i--)
           {
            ulong posTicket = PositionGetTicket(i);
            if(PositionSelectByTicket(posTicket))
              {
               Print("Position ticket: ",posTicket);
               if(trade.PositionClose(posTicket))
                 {
                  Print(__FUNCTION__," > Position number",posTicket,"was closed!");
                 }
              }
           }
         Comment("\n Server Time", TimeCurrent(),
                 "\nClose Time", timeClose);
        }
     }
   double DailyOpen = iOpen(_Symbol,PERIOD_CURRENT,0);
   Print("Daily Open: ", DailyOpen);
   double DailyPreviousOpen = iOpen(_Symbol,PERIOD_CURRENT,1);
   double DailyClose = iClose(_Symbol,PERIOD_CURRENT,1);
   Print("Daily Close: ", DailyClose);

   double SMAOneDay10Array[];
   double SMAOneDay20Array[];
   double SMAOneDay30Array[];
   double SMAOneDay50Array[];
   double SMAOneDay100Array[];
   double SMAOneDay200Array[];
   ArraySetAsSeries(SMAOneDay10Array, true);
   ArraySetAsSeries(SMAOneDay20Array, true);
   ArraySetAsSeries(SMAOneDay30Array, true);
   ArraySetAsSeries(SMAOneDay50Array, true);
   ArraySetAsSeries(SMAOneDay100Array, true);
   ArraySetAsSeries(SMAOneDay200Array, true);

   double EMAOneDay10Array[];
   double EMAOneDay20Array[];
   double EMAOneDay30Array[];
   double EMAOneDay50Array[];
   double EMAOneDay100Array[];
   double EMAOneDay200Array[];
   ArraySetAsSeries(EMAOneDay10Array, true);
   ArraySetAsSeries(EMAOneDay20Array, true);
   ArraySetAsSeries(EMAOneDay30Array, true);
   ArraySetAsSeries(EMAOneDay50Array, true);
   ArraySetAsSeries(EMAOneDay100Array, true);
   ArraySetAsSeries(EMAOneDay200Array, true);

   if(CopyBuffer(EMAOneDay10, 0, 0, 2, EMAOneDay10Array) < 2||
      CopyBuffer(EMAOneDay20, 0, 0, 2, EMAOneDay20Array) < 2||
      CopyBuffer(EMAOneDay30, 0, 0, 2, EMAOneDay30Array) < 2||
      CopyBuffer(EMAOneDay50, 0, 0, 2, EMAOneDay50Array) < 2||
      CopyBuffer(EMAOneDay100, 0, 0, 2, EMAOneDay100Array) < 2||
      CopyBuffer(EMAOneDay200, 0, 0, 2, EMAOneDay200Array) < 2||
      CopyBuffer(SMAOneDay10, 0, 0, 2, SMAOneDay10Array) < 2||
      CopyBuffer(SMAOneDay20, 0, 0, 2, SMAOneDay20Array) < 2||
      CopyBuffer(SMAOneDay30, 0, 0, 2, SMAOneDay30Array) < 2||
      CopyBuffer(SMAOneDay50, 0, 0, 2, SMAOneDay50Array) < 2||
      CopyBuffer(SMAOneDay100, 0, 0, 2, SMAOneDay100Array) < 2||
      CopyBuffer(SMAOneDay200, 0, 0, 2, SMAOneDay200Array) < 2)
     {
      Print("Failed to read MA indicator buffer");
      return;
     }

// This is the calculations for the moving averages for the 0 index (daily time frame)
   if(SMAOneDay10Array[1] < DailyOpen)
     {
      GetTotalResultOne = 1;
     }
   else
      if(SMAOneDay10Array[1] > DailyOpen)
        {
         GetTotalResultOne = -1;
        }
   if(SMAOneDay20Array[1] < DailyOpen)
     {
      GetTotalResultTwo = 1;
     }
   else
      if(SMAOneDay20Array[1] > DailyOpen)
        {
         GetTotalResultTwo = -1;
        }
   if(SMAOneDay30Array[1] < DailyOpen)
     {
      GetTotalResultThree = 1;
     }
   else
      if(SMAOneDay30Array[1] > DailyOpen)
        {
         GetTotalResultThree = -1;
        }
   if(SMAOneDay50Array[1] < DailyOpen)
     {
      GetTotalResultFour = 1;
     }
   else
      if(SMAOneDay50Array[1] > DailyOpen)
        {
         GetTotalResultFour = -1;
        }
   if(SMAOneDay100Array[1] < DailyOpen)
     {
      GetTotalResultFive = 1;
     }
   else
      if(SMAOneDay100Array[1] > DailyOpen)
        {
         GetTotalResultFive = -1;
        }
   if(SMAOneDay200Array[1] < DailyOpen)
     {
      GetTotalResultSix = 1;
     }
   else
      if(SMAOneDay200Array[1] > DailyOpen)
        {
         GetTotalResultSix = -1;
        }
   if(EMAOneDay10Array[1] < DailyOpen)
     {
      GetTotalResultSeven = 1;
     }
   else
      if(EMAOneDay10Array[1] > DailyOpen)
        {
         GetTotalResultSeven = -1;
        }
   if(EMAOneDay20Array[1] < DailyOpen)
     {
      GetTotalResultEight = 1;
     }
   else
      if(EMAOneDay20Array[1] > DailyOpen)
        {
         GetTotalResultEight = -1;
        }
   if(EMAOneDay30Array[1] < DailyOpen)
     {
      GetTotalResultNine = 1;
     }
   else
      if(EMAOneDay30Array[1] > DailyOpen)
        {
         GetTotalResultNine = -1;
        }
   if(EMAOneDay50Array[1] < DailyOpen)
     {
      GetTotalResultTen = 1;
     }
   else
      if(EMAOneDay50Array[1] > DailyOpen)
        {
         GetTotalResultTen = -1;
        }
   if(EMAOneDay100Array[1] < DailyOpen)
     {
      GetTotalResultEleven = 1;
     }
   else
      if(EMAOneDay100Array[1] > DailyOpen)
        {
         GetTotalResultEleven = -1;
        }
   if(EMAOneDay200Array[1] < DailyOpen)
     {
      GetTotalResultTwelve = 1;
     }
   else
      if(EMAOneDay200Array[1] > DailyOpen)
        {
         GetTotalResultTwelve = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double RSIOneDay[];
   ArraySetAsSeries(RSIOneDay, true);

   if(CopyBuffer(RSI, 0, 0, 3, RSIOneDay) < 3)
     {
      Print("Failed to read 'RSI indicator buffer");
      return;
     }
   if(RSIOneDay[1] > RSIOneDay[2])
     {
      RSIisRising = true;
     }
   if(RSIOneDay[1] < RSIOneDay[2])
     {
      RSIisFalling = true;
     }
   if((RSIOneDay[1] < 30)
      && (RSIisRising == true))
     {
      GetTotalResultThirteen = 1;
     }
   else
      if((RSIOneDay[1] > 70)
         && (RSIisFalling == true))
        {
         GetTotalResultThirteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double CCIOneDay[];
   ArraySetAsSeries(CCIOneDay, true);

   if(CopyBuffer(CCI, 0, 0, 3, CCIOneDay) < 3)
     {
      Print("Failed to read 'CCI indicator buffer");
      return;
     }

   if(CCIOneDay[1] > CCIOneDay[2])
     {
      CCIisRising = true;
     }
   if(CCIOneDay[1] < CCIOneDay[2])
     {
      CCIisFalling = true;
     }

   if((CCIOneDay[1] < -100)
      && (CCIisRising == true))
     {
      GetTotalResultFourteen = 1;
     }
   else
      if((CCIOneDay[1] > 100)
         && (CCIisFalling == true))
        {
         GetTotalResultFourteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double MomentumOneDay[];
   ArraySetAsSeries(MomentumOneDay, true);

   if(CopyBuffer(Momentum, 0, 0, 3, MomentumOneDay) < 3)
     {
      Print("Failed to read Momentum indicator buffer");
      return;
     }
   if(MomentumOneDay[1] > MomentumOneDay[2])
     {
      GetTotalResultFifteen = 1;
     }
   else
      if(MomentumOneDay[1] < MomentumOneDay[2])
        {
         GetTotalResultFifteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double WPROneDay[];
   ArraySetAsSeries(WPROneDay, true);

   if(CopyBuffer(WPR, 0, 0, 3, WPROneDay) < 3)
     {
      Print("Failed to read WPR indicator buffer");
      return;
     }

   if(WPROneDay[1] > WPROneDay[2])
     {
      WilliamsRPercentageisRising = true;
     }
   if(WPROneDay[1] < WPROneDay[2])
     {
      WilliamsRPercentageisFalling = true;
     }

   if((WPROneDay[1] < -80)
      && (WilliamsRPercentageisRising == true))
     {
      GetTotalResultSixteen = 1;
     }
   else
      if((WPROneDay[1] > -20)
         && (WilliamsRPercentageisFalling == true))
        {
         GetTotalResultSixteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BearOneDay[];
   ArraySetAsSeries(BearOneDay, true);

   if(CopyBuffer(Bear, 0, 0, 3, BearOneDay) < 3)
     {
      Print("Failed to read Bear indicator buffer");
      return;
     }

   if(BearOneDay[1] > BearOneDay[2])
     {
      BearPowerisRising = true;
     }

   double BullOneDay[];
   ArraySetAsSeries(BullOneDay, true);

   if(CopyBuffer(Bull, 0, 0, 3, BullOneDay) < 3)
     {
      Print("Failed to read Bull indicator buffer");
      return;
     }

   if(BullOneDay[1] < BullOneDay[2])
     {
      BullPowerisFalling = true;
     }
   if((BearOneDay[1] < 0)
      && (BearPowerisRising == true) && (DailyOpen > DailyPreviousOpen))
     {
      GetTotalResultSeventeen = 1;
     }
   else
      if((BullOneDay[1] > 0)
         && (BullPowerisFalling == true) && (DailyOpen < DailyPreviousOpen))
        {
         GetTotalResultSeventeen = -1;
        }

   double MACD_Main[];
   double MACD_Signal[];
   ArraySetAsSeries(MACD_Main, true);
   ArraySetAsSeries(MACD_Signal, true);

   if(CopyBuffer(MACD_handle, 0, 0, 2, MACD_Main) < 2 ||
      CopyBuffer(MACD_handle, 1, 0, 2, MACD_Signal) < 2)
     {
      Print("Failed to read MACD indicator buffer");
      return;
     }
   if(MACD_Main[1] > MACD_Signal[1])
     {
      GetTotalResultEighteen = 1;
     }
   else
      if(MACD_Main[1] < MACD_Signal[1])
        {
         GetTotalResultEighteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double Stochastic_Main[];
   double Stochastic_Signal[];
   ArraySetAsSeries(Stochastic_Main, true);
   ArraySetAsSeries(Stochastic_Signal, true);

   if(CopyBuffer(Stochastic_handle, 0, 0, 2, Stochastic_Main) < 2||
      CopyBuffer(Stochastic_handle, 1,0, 2, Stochastic_Signal) < 2)
     {
      Print("Failed to read Stochastic indicator buffer");
      return;
     }

   if(Stochastic_Main[1] > Stochastic_Signal[1] &&
      Stochastic_Signal[1] < 20 &&
      Stochastic_Main[1] < 20)
     {
      GetTotalResultNineteen = 1; // Buy: Main line crossed above signal line and is below 20
     }
   else
      if(Stochastic_Main[1] < Stochastic_Signal[1] &&
         Stochastic_Signal[1] > 80 &&
         Stochastic_Main[1] > 80)
        {
         GetTotalResultNineteen = -1; // Sell: Main line crossed below signal line and is above 80
        }

   double ADX_PlusDI[];
   double ADX_MinusDI[];
   ArraySetAsSeries(ADX_PlusDI, true);
   ArraySetAsSeries(ADX_MinusDI, true);

   if(CopyBuffer(ADX_handle, PLUSDI_LINE, 0, 3, ADX_PlusDI) < 3 ||
      CopyBuffer(ADX_handle, MINUSDI_LINE, 0, 3, ADX_MinusDI) < 3)
     {
      Print("Failed to read ADX indicator buffer");
      return;
     }

   if((ADX_MinusDI[2] < ADX_MinusDI[1]) &&(ADX_PlusDI[2] < ADX_PlusDI[1]))
      ADXIsRising = true;

   if((ADX_MinusDI[1] > 20) && (ADX_PlusDI[1] > 20) && (ADX_PlusDI[1] > ADX_MinusDI[1]) && ADXIsRising == true)
     {
      GetTotalResultTwenty = 1; // Buy: +DI crossed above -DI and ADX > 20
     }
   else
      if((ADX_MinusDI[1] > 20) && (ADX_PlusDI[1] > 20) && (ADX_PlusDI[1] < ADX_MinusDI[1]) && ADXIsRising == true)
        {
         GetTotalResultTwenty = -1; // Sell: +DI crossed below -DI and ADX > 20
        }

   double Ichimoku_BaseLine[];
   double Ichimoku_ConversionLine[];
   double Ichimoku_SenkouSpanA[];
   double Ichimoku_SenkouSpanB[];

   ArraySetAsSeries(Ichimoku_BaseLine, true);
   ArraySetAsSeries(Ichimoku_ConversionLine, true);
   ArraySetAsSeries(Ichimoku_SenkouSpanA, true);
   ArraySetAsSeries(Ichimoku_SenkouSpanB, true);

   if(CopyBuffer(IchimokuCloud_handle, KIJUNSEN_LINE, 0, 2, Ichimoku_BaseLine) < 2||
      CopyBuffer(IchimokuCloud_handle, TENKANSEN_LINE, 0, 2, Ichimoku_ConversionLine) < 2||
      CopyBuffer(IchimokuCloud_handle, SENKOUSPANA_LINE, 0, 2, Ichimoku_SenkouSpanA) < 2||
      CopyBuffer(IchimokuCloud_handle, SENKOUSPANB_LINE, 0, 2, Ichimoku_SenkouSpanB) < 2)
     {
      Print("Failed to read Ichimoku indicator buffer");
      return;
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(Ichimoku_SenkouSpanA[1] < Ichimoku_BaseLine[1] &&  //BaseLine > Leadline 1
      Ichimoku_BaseLine[1] > Ichimoku_ConversionLine[1] && //Baseline > Conversion Line
      Ichimoku_ConversionLine[1] < DailyOpen && //Price < ConversionLine
      Ichimoku_SenkouSpanA[1] > Ichimoku_SenkouSpanB[1]) //Leadline 1 > Leadline 2
     {
      GetTotalResultTwentyOne = 1; //Buy
     }
   else
      if(Ichimoku_SenkouSpanA[1] > Ichimoku_BaseLine[1] &&  //BaseLine < Leadline 1
         Ichimoku_BaseLine[1] < Ichimoku_ConversionLine[1] && //Baseline < Conversion Line
         Ichimoku_ConversionLine[1] > DailyOpen && //Price > ConversionLine
         Ichimoku_SenkouSpanA[1] < Ichimoku_SenkouSpanB[1]) //Leadline 1 < Leadline 2
        {
         GetTotalResultTwentyOne = -1; //Sell
        }

   double AOOneDay[];
   ArraySetAsSeries(AOOneDay, true);

   if(CopyBuffer(AO, MAIN_LINE, 0, 2, AOOneDay) < 2)
     {
      Print("Failed to read AO indicator buffer");
      return;
     }

   double OneDayOpenArray[];
   ArraySetAsSeries(OneDayOpenArray, true);

   if(CopyOpen(_Symbol,PERIOD_CURRENT,0,4,OneDayOpenArray) < 4)
     {
      Print("Failed to read Open Price buffer");
      return;
     }

   if((AOOneDay[1] > 0) && (OneDayOpenArray[3] > OneDayOpenArray[2]) && (OneDayOpenArray[2] > OneDayOpenArray[1]) && (OneDayOpenArray[1] < OneDayOpenArray[0]))
     {
      GetTotalResultTwentyTwo = 1;
     }
   else
      if((AOOneDay[1] < 0) && (OneDayOpenArray[3] < OneDayOpenArray[2]) && (OneDayOpenArray[2] < OneDayOpenArray[1]) && (OneDayOpenArray[1] > OneDayOpenArray[0]))
        {
         GetTotalResultTwentyTwo = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double OneDayCalculationPreCalculationMA = (GetTotalResultOne + GetTotalResultTwo + GetTotalResultThree + GetTotalResultFour + GetTotalResultFive + GetTotalResultSix + GetTotalResultSeven + GetTotalResultEight + GetTotalResultNine + GetTotalResultTen + GetTotalResultEleven + GetTotalResultTwelve + GetTotalResultTwentyOne);
   double OneDayCalculationMA = NormalizeDouble(OneDayCalculationPreCalculationMA,3)/13;
   Print("OneDayCalculationMA", OneDayCalculationMA);

   double OneDayCalculationPreCalculationOS = (GetTotalResultThirteen + GetTotalResultFourteen + GetTotalResultFifteen + GetTotalResultSixteen + GetTotalResultSeventeen + GetTotalResultEighteen + GetTotalResultNineteen + GetTotalResultTwenty + GetTotalResultTwentyTwo);
   double OneDayCalculationOS = NormalizeDouble(OneDayCalculationPreCalculationOS,3)/9;
   Print("OneDayCalculationOS", OneDayCalculationOS);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

   double UnrealziedPnL = ACCOUNT_PROFIT;
   double AccountEquity = ACCOUNT_EQUITY;
   double StopLossCalculation = (((UnrealziedPnL / AccountEquity)*100) * Leverage);
   double StopLoss = StopLossCalculation <= -5;

   double BuyPrice = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
   Print("Buy Price: ", BuyPrice);
   double SellPrice = SymbolInfoDouble(_Symbol,SYMBOL_BID);
   Print("Sell Price: ", SellPrice);
   Print("Daily Open: ", DailyOpen);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// Check overall conditions for placing a trade
   double DailyHigh = iHigh(_Symbol,PERIOD_CURRENT,1);
   double DailyLow = iLow(_Symbol,PERIOD_CURRENT,1);

//double PivotPointPreCalculation = (DailyClose + DailyHigh + DailyLow);
//double PivotPointValue = PivotPointPreCalculation/3;
//Print("PivotPointValue", PivotPointValue);

//double PivotPointR1PreCalculation = (PivotPointValue * 2);
//double PivotPointR1Calculation = (PivotPointR1PreCalculation - DailyLow);// This is for the high value above the pivot point
//Print("PivotPointR1Calculation", PivotPointR1Calculation);

//double PivotPointS1PreCalculation = (PivotPointValue * 2);
//double PivotPointS1Calculation = (PivotPointS1PreCalculation - DailyHigh);// This is for the low value below the pivot point
//Print("PivotPointS1Calculation", PivotPointS1Calculation);

// Check overall conditions for placing a trade
   static datetime prevTime=0;
   datetime lastTime[1];
   if(CopyTime(_Symbol,PERIOD_CURRENT,0,1,lastTime)==1 && prevTime!=lastTime[0])
     {
      prevTime=lastTime[0];

      if(OneDayCalculationMA > 0.9 && OneDayCalculationOS > 0 && BuyPrice < DailyOpen)// && BuyPrice < PivotPointValue && BuyPrice < PivotPointS1Calculation)
        {
         double EnterLong = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
         EnterLong = NormalizeDouble(EnterLong,_Digits);
         trade.Buy(Lots,NULL,EnterLong,StopLoss,NULL,"Enter Long");
        }

      // Check conditions to enter a short position
      if(OneDayCalculationMA < -0.9 && OneDayCalculationOS < 0 && SellPrice > DailyOpen)// && SellPrice > PivotPointValue && SellPrice > PivotPointR1Calculation)
        {
         double EnterShort = SymbolInfoDouble(_Symbol,SYMBOL_BID);
         EnterShort = NormalizeDouble(EnterShort,_Digits);
         trade.Sell(Lots,NULL,EnterShort,StopLoss,NULL,"Enter Short");
        }
     }
  }
//+-----------------------------------------------------------------+
//+------------------------------------------------------------------+